#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_StarLotteryEventCFG.h"
std::auto_ptr<M_StarLotteryEventCFG> M_StarLotteryEventCFG::msSingleton(nullptr);

int M_StarLotteryEventCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_StarLotteryEventCFGData* M_StarLotteryEventCFG::GetData(int Type)
{
	auto it = mMapData.find(Type);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_StarLotteryEventCFGData>& M_StarLotteryEventCFG::GetMapData()
{
	return mMapData;
}

void M_StarLotteryEventCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_StarLotteryEventCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_StarLotteryEventCFGData data;
		data.mType = element->IntAttribute("Type");
		data.mDailyADD = element->IntAttribute("DailyADD");
		data.mTotalADD = element->IntAttribute("TotalADD");
		if (mMapData.find(data.mType) != mMapData.end())std::cout <<"data refind:" << data.mType << std::endl;
		CCASSERT(mMapData.find(data.mType) == mMapData.end(), "data.mType is exists");
		mMapData.insert(std::make_pair(data.mType, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_StarLotteryEventCFG Loaded. Load Data:%u", mMapData.size());
}

void M_StarLotteryEventCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_StarLotteryEventCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_StarLotteryEventCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_StarLotteryEventCFGData data;
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "DailyADD", data.mDailyADD);
		LuaCfgHelper::readInt(L, "TotalADD", data.mTotalADD);
		if (mMapData.find(data.mType) != mMapData.end())std::cout <<"data refind:" << data.mType << std::endl;
		CCASSERT(mMapData.find(data.mType) == mMapData.end(), "data.mType is exists");
		mMapData.insert(std::make_pair(data.mType, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_StarLotteryEventCFG Loaded. Load Data:%u", mMapData.size());
}

void M_StarLotteryEventCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_StarLotteryEventCFG* M_StarLotteryEventCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_StarLotteryEventCFG());
	}
	return msSingleton.get();
}

void M_StarLotteryEventCFG::Release()
{
	msSingleton.reset(nullptr);
}
